diff --git a/llvm/test/MC/X86/intel-syntax-x86-64-avx.s b/llvm/test/MC/X86/intel-syntax-x86-64-avx.s
index 3fdb758b0a0..bb57cb287f3 100644
--- a/llvm/test/MC/X86/intel-syntax-x86-64-avx.s
+++ b/llvm/test/MC/X86/intel-syntax-x86-64-avx.s
@@ -68,98 +68,50 @@
 // CHECK: encoding: [0xc4,0xc1,0x79,0x5a,0xc7]
           vcvtpd2ps xmm0, xmm15
 
-// CHECK: vcvtpd2ps xmm0, xmm15 
-// CHECK: encoding: [0xc4,0xc1,0x79,0x5a,0xc7]
-          vcvtpd2psx xmm0, xmm15
-
 // CHECK: vcvtpd2ps xmm0, xmmword ptr [rax]
 // CHECK: encoding: [0xc5,0xf9,0x5a,0x00]
           vcvtpd2ps xmm0, xmmword ptr [rax]
 
-// CHECK: vcvtpd2ps xmm0, xmmword ptr [rax]
-// CHECK: encoding: [0xc5,0xf9,0x5a,0x00]
-          vcvtpd2psx xmm0, xmmword ptr [rax]
-
 // CHECK: vcvtpd2ps xmm0, ymm15 
 // CHECK: encoding: [0xc4,0xc1,0x7d,0x5a,0xc7]
           vcvtpd2ps xmm0, ymm15
 
-// CHECK: vcvtpd2ps xmm0, ymm15 
-// CHECK: encoding: [0xc4,0xc1,0x7d,0x5a,0xc7]
-          vcvtpd2psy xmm0, ymm15
-
 // CHECK: vcvtpd2ps xmm0, ymmword ptr [rax]
 // CHECK: encoding: [0xc5,0xfd,0x5a,0x00]
           vcvtpd2ps xmm0, ymmword ptr [rax]
 
-// CHECK: vcvtpd2ps xmm0, ymmword ptr [rax]
-// CHECK: encoding: [0xc5,0xfd,0x5a,0x00]
-          vcvtpd2psy xmm0, ymmword ptr [rax]
-
 // CHECK: vcvtpd2dq xmm0, xmm15 
 // CHECK: encoding: [0xc4,0xc1,0x7b,0xe6,0xc7]
           vcvtpd2dq xmm0, xmm15
 
-// CHECK: vcvtpd2dq xmm0, xmm15 
-// CHECK: encoding: [0xc4,0xc1,0x7b,0xe6,0xc7]
-          vcvtpd2dqx xmm0, xmm15
-
 // CHECK: vcvtpd2dq xmm0, xmmword ptr [rax]
 // CHECK: encoding: [0xc5,0xfb,0xe6,0x00]
           vcvtpd2dq xmm0, xmmword ptr [rax]
 
-// CHECK: vcvtpd2dq xmm0, xmmword ptr [rax]
-// CHECK: encoding: [0xc5,0xfb,0xe6,0x00]
-          vcvtpd2dqx xmm0, xmmword ptr [rax]
-
 // CHECK: vcvtpd2dq xmm0, ymm15 
 // CHECK: encoding: [0xc4,0xc1,0x7f,0xe6,0xc7]
           vcvtpd2dq xmm0, ymm15
 
-// CHECK: vcvtpd2dq xmm0, ymm15 
-// CHECK: encoding: [0xc4,0xc1,0x7f,0xe6,0xc7]
-          vcvtpd2dqy xmm0, ymm15
-
 // CHECK: vcvtpd2dq xmm0, ymmword ptr [rax]
 // CHECK: encoding: [0xc5,0xff,0xe6,0x00]
           vcvtpd2dq xmm0, ymmword ptr [rax]
 
-// CHECK: vcvtpd2dq xmm0, ymmword ptr [rax]
-// CHECK: encoding: [0xc5,0xff,0xe6,0x00]
-          vcvtpd2dqy xmm0, ymmword ptr [rax]
-
 // CHECK: vcvttpd2dq xmm0, xmm15 
 // CHECK: encoding: [0xc4,0xc1,0x79,0xe6,0xc7]
           vcvttpd2dq xmm0, xmm15
 
-// CHECK: vcvttpd2dq xmm0, xmm15 
-// CHECK: encoding: [0xc4,0xc1,0x79,0xe6,0xc7]
-          vcvttpd2dqx xmm0, xmm15
-
 // CHECK: vcvttpd2dq xmm0, xmmword ptr [rax]
 // CHECK: encoding: [0xc5,0xf9,0xe6,0x00]
           vcvttpd2dq xmm0, xmmword ptr [rax]
 
-// CHECK: vcvttpd2dq xmm0, xmmword ptr [rax]
-// CHECK: encoding: [0xc5,0xf9,0xe6,0x00]
-          vcvttpd2dqx xmm0, xmmword ptr [rax]
-
 // CHECK: vcvttpd2dq xmm0, ymm15 
 // CHECK: encoding: [0xc4,0xc1,0x7d,0xe6,0xc7]
           vcvttpd2dq xmm0, ymm15
 
-// CHECK: vcvttpd2dq xmm0, ymm15 
-// CHECK: encoding: [0xc4,0xc1,0x7d,0xe6,0xc7]
-          vcvttpd2dqy xmm0, ymm15
-
 // CHECK: vcvttpd2dq xmm0, ymmword ptr [rax]
 // CHECK: encoding: [0xc5,0xfd,0xe6,0x00]
           vcvttpd2dq xmm0, ymmword ptr [rax]
 
-// CHECK: vcvttpd2dq xmm0, ymmword ptr [rax]
-// CHECK: encoding: [0xc5,0xfd,0xe6,0x00]
-          vcvttpd2dqy xmm0, ymmword ptr [rax]
-
 // CHECK: vpmaddwd xmm1, xmm2, xmm3
 // CHECK: encoding: [0xc5,0xe9,0xf5,0xcb]
           vpmaddwd xmm1, xmm2, xmm3
diff --git a/llvm/test/MC/X86/intel-syntax-x86-64-avx512f_vl.s b/llvm/test/MC/X86/intel-syntax-x86-64-avx512f_vl.s
index b98d230fad2..29bde03c586 100644
--- a/llvm/test/MC/X86/intel-syntax-x86-64-avx512f_vl.s
+++ b/llvm/test/MC/X86/intel-syntax-x86-64-avx512f_vl.s
@@ -1124,226 +1124,114 @@
 // CHECK: encoding: [0x62,0xb1,0xfd,0x08,0x5a,0xc7]
           vcvtpd2ps xmm0, xmm23
 
-// CHECK: vcvtpd2ps xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xfd,0x08,0x5a,0xc7]
-          vcvtpd2psx xmm0, xmm23
-
 // CHECK: vcvtpd2ps xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfd,0x08,0x5a,0x00]
           vcvtpd2ps xmm16, xmmword ptr [rax]
 
-// CHECK: vcvtpd2ps xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfd,0x08,0x5a,0x00]
-          vcvtpd2psx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvtpd2ps xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xfd,0x28,0x5a,0xc7]
           vcvtpd2ps xmm0, ymm23
 
-// CHECK: vcvtpd2ps xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xfd,0x28,0x5a,0xc7]
-          vcvtpd2psy xmm0, ymm23
-
 // CHECK: vcvtpd2ps xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfd,0x28,0x5a,0x00]
           vcvtpd2ps xmm16, ymmword ptr [rax]
 
-// CHECK: vcvtpd2ps xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfd,0x28,0x5a,0x00]
-          vcvtpd2psy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvtpd2dq xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xff,0x08,0xe6,0xc7]
           vcvtpd2dq xmm0, xmm23
 
-// CHECK: vcvtpd2dq xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xff,0x08,0xe6,0xc7]
-          vcvtpd2dqx xmm0, xmm23
-
 // CHECK: vcvtpd2dq xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xff,0x08,0xe6,0x00]
           vcvtpd2dq xmm16, xmmword ptr [rax]
 
-// CHECK: vcvtpd2dq xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xff,0x08,0xe6,0x00]
-          vcvtpd2dqx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvtpd2dq xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xff,0x28,0xe6,0xc7]
           vcvtpd2dq xmm0, ymm23
 
-// CHECK: vcvtpd2dq xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xff,0x28,0xe6,0xc7]
-          vcvtpd2dqy xmm0, ymm23
-
 // CHECK: vcvtpd2dq xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xff,0x28,0xe6,0x00]
           vcvtpd2dq xmm16, ymmword ptr [rax]
 
-// CHECK: vcvtpd2dq xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xff,0x28,0xe6,0x00]
-          vcvtpd2dqy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvtpd2udq xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x79,0xc7]
           vcvtpd2udq xmm0, xmm23
 
-// CHECK: vcvtpd2udq xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x79,0xc7]
-          vcvtpd2udqx xmm0, xmm23
-
 // CHECK: vcvtpd2udq xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x79,0x00]
           vcvtpd2udq xmm16, xmmword ptr [rax]
 
-// CHECK: vcvtpd2udq xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x79,0x00]
-          vcvtpd2udqx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvtpd2udq xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x79,0xc7]
           vcvtpd2udq xmm0, ymm23
 
-// CHECK: vcvtpd2udq xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x79,0xc7]
-          vcvtpd2udqy xmm0, ymm23
-
 // CHECK: vcvtpd2udq xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x79,0x00]
           vcvtpd2udq xmm16, ymmword ptr [rax]
 
-// CHECK: vcvtpd2udq xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x79,0x00]
-          vcvtpd2udqy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvttpd2dq xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xfd,0x08,0xe6,0xc7]
           vcvttpd2dq xmm0, xmm23
 
-// CHECK: vcvttpd2dq xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xfd,0x08,0xe6,0xc7]
-          vcvttpd2dqx xmm0, xmm23
-
 // CHECK: vcvttpd2dq xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfd,0x08,0xe6,0x00]
           vcvttpd2dq xmm16, xmmword ptr [rax]
 
-// CHECK: vcvttpd2dq xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfd,0x08,0xe6,0x00]
-          vcvttpd2dqx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvttpd2dq xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xfd,0x28,0xe6,0xc7]
           vcvttpd2dq xmm0, ymm23
 
-// CHECK: vcvttpd2dq xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xfd,0x28,0xe6,0xc7]
-          vcvttpd2dqy xmm0, ymm23
-
 // CHECK: vcvttpd2dq xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfd,0x28,0xe6,0x00]
           vcvttpd2dq xmm16, ymmword ptr [rax]
 
-// CHECK: vcvttpd2dq xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfd,0x28,0xe6,0x00]
-          vcvttpd2dqy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvttpd2udq xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x78,0xc7]
           vcvttpd2udq xmm0, xmm23
 
-// CHECK: vcvttpd2udq xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x78,0xc7]
-          vcvttpd2udqx xmm0, xmm23
-
 // CHECK: vcvttpd2udq xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x78,0x00]
           vcvttpd2udq xmm16, xmmword ptr [rax]
 
-// CHECK: vcvttpd2udq xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x78,0x00]
-          vcvttpd2udqx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvttpd2udq xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x78,0xc7]
           vcvttpd2udq xmm0, ymm23
 
-// CHECK: vcvttpd2udq xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x78,0xc7]
-          vcvttpd2udqy xmm0, ymm23
-
 // CHECK: vcvttpd2udq xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x78,0x00]
           vcvttpd2udq xmm16, ymmword ptr [rax]
 
-// CHECK: vcvttpd2udq xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x78,0x00]
-          vcvttpd2udqy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvtqq2ps xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x5b,0xc7]
           vcvtqq2ps xmm0, xmm23
 
-// CHECK: vcvtqq2ps xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x08,0x5b,0xc7]
-          vcvtqq2psx xmm0, xmm23
-
 // CHECK: vcvtqq2ps xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x5b,0x00]
           vcvtqq2ps xmm16, xmmword ptr [rax]
 
-// CHECK: vcvtqq2ps xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x08,0x5b,0x00]
-          vcvtqq2psx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvtqq2ps xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x5b,0xc7]
           vcvtqq2ps xmm0, ymm23
 
-// CHECK: vcvtqq2ps xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xfc,0x28,0x5b,0xc7]
-          vcvtqq2psy xmm0, ymm23
-
 // CHECK: vcvtqq2ps xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x5b,0x00]
           vcvtqq2ps xmm16, ymmword ptr [rax]
 
-// CHECK: vcvtqq2ps xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xfc,0x28,0x5b,0x00]
-          vcvtqq2psy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvtuqq2ps xmm0, xmm23 
 // CHECK: encoding: [0x62,0xb1,0xff,0x08,0x7a,0xc7]
           vcvtuqq2ps xmm0, xmm23
 
-// CHECK: vcvtuqq2ps xmm0, xmm23 
-// CHECK: encoding: [0x62,0xb1,0xff,0x08,0x7a,0xc7]
-          vcvtuqq2psx xmm0, xmm23
-
 // CHECK: vcvtuqq2ps xmm16, xmmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xff,0x08,0x7a,0x00]
           vcvtuqq2ps xmm16, xmmword ptr [rax]
 
-// CHECK: vcvtuqq2ps xmm16, xmmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xff,0x08,0x7a,0x00]
-          vcvtuqq2psx xmm16, xmmword ptr [rax]
-
 // CHECK: vcvtuqq2ps xmm0, ymm23 
 // CHECK: encoding: [0x62,0xb1,0xff,0x28,0x7a,0xc7]
           vcvtuqq2ps xmm0, ymm23
 
-// CHECK: vcvtuqq2ps xmm0, ymm23 
-// CHECK: encoding: [0x62,0xb1,0xff,0x28,0x7a,0xc7]
-          vcvtuqq2psy xmm0, ymm23
-
 // CHECK: vcvtuqq2ps xmm16, ymmword ptr [rax]
 // CHECK: encoding: [0x62,0xe1,0xff,0x28,0x7a,0x00]
           vcvtuqq2ps xmm16, ymmword ptr [rax]
 
-// CHECK: vcvtuqq2ps xmm16, ymmword ptr [rax]
-// CHECK: encoding: [0x62,0xe1,0xff,0x28,0x7a,0x00]
-          vcvtuqq2psy xmm16, ymmword ptr [rax]
-
 // CHECK: vcvtps2pd xmm1 {k2} {z}, qword ptr [rcx + 128]
 // CHECK:  encoding: [0x62,0xf1,0x7c,0x8a,0x5a,0x49,0x10]
           vcvtps2pd xmm1 {k2} {z}, qword ptr [rcx+0x80]
diff --git a/llvm/test/MC/X86/intel-syntax-x86-avx512dq_vl.s b/llvm/test/MC/X86/intel-syntax-x86-avx512dq_vl.s
index 7693caba450..e2d6850623a 100644
--- a/llvm/test/MC/X86/intel-syntax-x86-avx512dq_vl.s
+++ b/llvm/test/MC/X86/intel-syntax-x86-avx512dq_vl.s
@@ -95,3 +95,99 @@
 // CHECK:  vcvttps2uqq xmm1, qword ptr [rcx + 128]
 // CHECK:  encoding: [0x62,0xf1,0x7d,0x08,0x78,0x49,0x10]
           vcvttps2uqq xmm1, qword ptr [rcx + 128]
+
+// CHECK: vfpclasspd k2, xmm18, 171
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x08,0x66,0xd2,0xab]
+          vfpclasspd k2, xmm18, 0xab
+
+// CHECK: vfpclasspd k2 {k7}, xmm18, 171
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x0f,0x66,0xd2,0xab]
+          vfpclasspd k2 {k7}, xmm18, 0xab
+
+// CHECK: vfpclasspd k2, xmmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x08,0x66,0x11,0x7b]
+          vfpclasspd k2, xmmword ptr [rcx], 0x7b
+
+// CHECK: vfpclasspd k2 {k7}, xmmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x0f,0x66,0x11,0x7b]
+          vfpclasspd k2 {k7}, xmmword ptr [rcx], 0x7b
+
+// CHECK: vfpclasspd k2, qword ptr [rcx]{1to2}, 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x18,0x66,0x11,0x7b]
+          vfpclasspd k2, qword ptr [rcx]{1to2}, 0x7b
+
+// CHECK: vfpclasspd k2 {k7}, qword ptr [rcx]{1to2}, 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x1f,0x66,0x11,0x7b]
+          vfpclasspd k2 {k7}, qword ptr [rcx]{1to2}, 0x7b
+
+// CHECK: vfpclassps k2, xmm18, 171
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x08,0x66,0xd2,0xab]
+          vfpclassps k2, xmm18, 0xab
+
+// CHECK: vfpclassps k2 {k7}, xmm18, 171
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x0f,0x66,0xd2,0xab]
+          vfpclassps k2 {k7}, xmm18, 0xab
+
+// CHECK: vfpclassps k2, xmmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x08,0x66,0x11,0x7b]
+          vfpclassps k2, xmmword ptr [rcx], 0x7b
+
+// CHECK: vfpclassps k2 {k7}, xmmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x0f,0x66,0x11,0x7b]
+          vfpclassps k2 {k7}, xmmword ptr [rcx], 0x7b
+
+// CHECK: vfpclassps k2, dword ptr [rcx]{1to4}, 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x18,0x66,0x11,0x7b]
+          vfpclassps k2, dword ptr [rcx]{1to4}, 0x7b
+
+// CHECK: vfpclassps k2 {k7}, dword ptr [rcx]{1to4}, 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x1f,0x66,0x11,0x7b]
+          vfpclassps k2 {k7}, dword ptr [rcx]{1to4}, 0x7b
+
+// CHECK: vfpclasspd k2, ymm18, 171
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x28,0x66,0xd2,0xab]
+          vfpclasspd k2, ymm18, 0xab
+
+// CHECK: vfpclasspd k2 {k7}, ymm18, 171
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x2f,0x66,0xd2,0xab]
+          vfpclasspd k2 {k7}, ymm18, 0xab
+
+// CHECK: vfpclasspd k2, ymmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x28,0x66,0x11,0x7b]
+          vfpclasspd k2, ymmword ptr [rcx], 0x7b
+
+// CHECK: vfpclasspd k2 {k7}, ymmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x2f,0x66,0x11,0x7b]
+          vfpclasspd k2 {k7}, ymmword ptr [rcx], 0x7b
+
+// CHECK: vfpclasspd k2, qword ptr [rcx]{1to4}, 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x38,0x66,0x11,0x7b]
+          vfpclasspd k2, qword ptr [rcx]{1to4}, 0x7b
+
+// CHECK: vfpclasspd k2 {k7}, qword ptr [rcx]{1to4}, 123
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x3f,0x66,0x11,0x7b]
+          vfpclasspd k2 {k7}, qword ptr [rcx]{1to4}, 0x7b
+
+// CHECK: vfpclassps k2, ymm18, 171
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x28,0x66,0xd2,0xab]
+          vfpclassps k2, ymm18, 0xab
+
+// CHECK: vfpclassps k2 {k7}, ymm18, 171
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x2f,0x66,0xd2,0xab]
+          vfpclassps k2 {k7}, ymm18, 0xab
+
+// CHECK: vfpclassps k2, ymmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x28,0x66,0x11,0x7b]
+          vfpclassps k2, ymmword ptr [rcx], 0x7b
+
+// CHECK: vfpclassps k2 {k7}, ymmword ptr [rcx], 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x2f,0x66,0x11,0x7b]
+          vfpclassps k2 {k7}, ymmword ptr [rcx], 0x7b
+
+// CHECK: vfpclassps k2, dword ptr [rcx]{1to8}, 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x38,0x66,0x11,0x7b]
+          vfpclassps k2, dword ptr [rcx]{1to8}, 0x7b
+
+// CHECK: vfpclassps k2 {k7}, dword ptr [rcx]{1to8}, 123
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x3f,0x66,0x11,0x7b]
+          vfpclassps k2 {k7}, dword ptr [rcx]{1to8}, 0x7b
diff --git a/llvm/test/MC/X86/x86-64-avx512dq.s b/llvm/test/MC/X86/x86-64-avx512dq.s
index 91014a7cb43..4510352ee7c 100644
--- a/llvm/test/MC/X86/x86-64-avx512dq.s
+++ b/llvm/test/MC/X86/x86-64-avx512dq.s
@@ -3495,14 +3495,26 @@
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd1,0xab]
           vfpclasspd $0xab, %zmm17, %k2
 
+// CHECK: vfpclasspd $171, %zmm17, %k2
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd1,0xab]
+          vfpclasspdz $0xab, %zmm17, %k2
+
 // CHECK: vfpclasspd $171, %zmm17, %k2 {%k1}
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x49,0x66,0xd1,0xab]
           vfpclasspd $0xab, %zmm17, %k2 {%k1}
 
+// CHECK: vfpclasspd $171, %zmm17, %k2 {%k1}
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x49,0x66,0xd1,0xab]
+          vfpclasspdz $0xab, %zmm17, %k2 {%k1}
+
 // CHECK: vfpclasspd $123,  %zmm17, %k2
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd1,0x7b]
           vfpclasspd $0x7b, %zmm17, %k2
 
+// CHECK: vfpclasspd $123,  %zmm17, %k2
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd1,0x7b]
+          vfpclasspdz $0x7b, %zmm17, %k2
+
 // CHECK: vfpclasspdz $123, (%rcx), %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x11,0x7b]
           vfpclasspdz $0x7b,(%rcx), %k2
@@ -3511,9 +3523,9 @@
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0x94,0xf0,0x23,0x01,0x00,0x00,0x7b]
           vfpclasspdz $0x7b,291(%rax,%r14,8), %k2
 
-// CHECK: vfpclasspdq $123, (%rcx){1to8}, %k2
+// CHECK: vfpclasspd $123, (%rcx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x11,0x7b]
-          vfpclasspdq $0x7b,(%rcx){1to8}, %k2
+          vfpclasspd $0x7b,(%rcx){1to8}, %k2
 
 // CHECK: vfpclasspdz $123, 8128(%rdx), %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x52,0x7f,0x7b]
@@ -3531,34 +3543,62 @@
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x92,0xc0,0xdf,0xff,0xff,0x7b]
           vfpclasspdz $0x7b,-8256(%rdx), %k2
 
-// CHECK: vfpclasspdq $123, 1016(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, 1016(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x7f,0x7b]
-          vfpclasspdq $0x7b,1016(%rdx){1to8}, %k2
+          vfpclasspd $0x7b,1016(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, 1024(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, 1016(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x7f,0x7b]
+          vfpclasspdz $0x7b,1016(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, 1024(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0x00,0x04,0x00,0x00,0x7b]
+          vfpclasspd $0x7b,1024(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, 1024(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0x00,0x04,0x00,0x00,0x7b]
-          vfpclasspdq $0x7b,1024(%rdx){1to8}, %k2
+          vfpclasspdz $0x7b,1024(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, -1024(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x80,0x7b]
+          vfpclasspd $0x7b,-1024(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, -1024(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, -1024(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x80,0x7b]
-          vfpclasspdq $0x7b,-1024(%rdx){1to8}, %k2
+          vfpclasspdz $0x7b,-1024(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, -1032(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, -1032(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0xf8,0xfb,0xff,0xff,0x7b]
-          vfpclasspdq $0x7b,-1032(%rdx){1to8}, %k2
+          vfpclasspd $0x7b,-1032(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, -1032(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0xf8,0xfb,0xff,0xff,0x7b]
+          vfpclasspdz $0x7b,-1032(%rdx){1to8}, %k2
 
 // CHECK: vfpclassps $171, %zmm21, %k2
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xd5,0xab]
           vfpclassps $0xab, %zmm21, %k2
 
+// CHECK: vfpclassps $171, %zmm21, %k2
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xd5,0xab]
+          vfpclasspsz $0xab, %zmm21, %k2
+
 // CHECK: vfpclassps $171, %zmm21, %k2 {%k2}
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x4a,0x66,0xd5,0xab]
           vfpclassps $0xab, %zmm21, %k2 {%k2}
 
+// CHECK: vfpclassps $171, %zmm21, %k2 {%k2}
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x4a,0x66,0xd5,0xab]
+          vfpclasspsz $0xab, %zmm21, %k2 {%k2}
+
 // CHECK: vfpclassps $123,  %zmm21, %k2
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xd5,0x7b]
           vfpclassps $0x7b, %zmm21, %k2
 
+// CHECK: vfpclassps $123,  %zmm21, %k2
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xd5,0x7b]
+          vfpclasspsz $0x7b, %zmm21, %k2
+
 // CHECK: vfpclasspsz $123, (%rcx), %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0x11,0x7b]
           vfpclasspsz $0x7b,(%rcx), %k2
@@ -3567,9 +3607,13 @@
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0x94,0xf0,0x23,0x01,0x00,0x00,0x7b]
           vfpclasspsz $0x7b,291(%rax,%r14,8), %k2
 
-// CHECK: vfpclasspsl $123, (%rcx){1to16}, %k2
+// CHECK: vfpclassps $123, (%rcx){1to16}, %k2
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x11,0x7b]
+          vfpclassps $0x7b,(%rcx){1to16}, %k2
+
+// CHECK: vfpclassps $123, (%rcx){1to16}, %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x11,0x7b]
-          vfpclasspsl $0x7b,(%rcx){1to16}, %k2
+          vfpclasspsz $0x7b,(%rcx){1to16}, %k2
 
 // CHECK: vfpclasspsz $123, 8128(%rdx), %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0x52,0x7f,0x7b]
@@ -3587,34 +3631,62 @@
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0x92,0xc0,0xdf,0xff,0xff,0x7b]
           vfpclasspsz $0x7b,-8256(%rdx), %k2
 
-// CHECK: vfpclasspsl $123, 508(%rdx){1to16}, %k2
+// CHECK: vfpclassps $123, 508(%rdx){1to16}, %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x52,0x7f,0x7b]
-          vfpclasspsl $0x7b,508(%rdx){1to16}, %k2
+          vfpclassps $0x7b,508(%rdx){1to16}, %k2
 
-// CHECK: vfpclasspsl $123, 512(%rdx){1to16}, %k2
+// CHECK: vfpclassps $123, 508(%rdx){1to16}, %k2
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x52,0x7f,0x7b]
+          vfpclasspsz $0x7b,508(%rdx){1to16}, %k2
+
+// CHECK: vfpclassps $123, 512(%rdx){1to16}, %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x92,0x00,0x02,0x00,0x00,0x7b]
-          vfpclasspsl $0x7b,512(%rdx){1to16}, %k2
+          vfpclassps $0x7b,512(%rdx){1to16}, %k2
 
-// CHECK: vfpclasspsl $123, -512(%rdx){1to16}, %k2
+// CHECK: vfpclassps $123, 512(%rdx){1to16}, %k2
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x92,0x00,0x02,0x00,0x00,0x7b]
+          vfpclasspsz $0x7b,512(%rdx){1to16}, %k2
+
+// CHECK: vfpclassps $123, -512(%rdx){1to16}, %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x52,0x80,0x7b]
-          vfpclasspsl $0x7b,-512(%rdx){1to16}, %k2
+          vfpclassps $0x7b,-512(%rdx){1to16}, %k2
 
-// CHECK: vfpclasspsl $123, -516(%rdx){1to16}, %k2
+// CHECK: vfpclassps $123, -512(%rdx){1to16}, %k2
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x52,0x80,0x7b]
+          vfpclasspsz $0x7b,-512(%rdx){1to16}, %k2
+
+// CHECK: vfpclassps $123, -516(%rdx){1to16}, %k2
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x92,0xfc,0xfd,0xff,0xff,0x7b]
+          vfpclassps $0x7b,-516(%rdx){1to16}, %k2
+
+// CHECK: vfpclassps $123, -516(%rdx){1to16}, %k2
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x92,0xfc,0xfd,0xff,0xff,0x7b]
-          vfpclasspsl $0x7b,-516(%rdx){1to16}, %k2
+          vfpclasspsz $0x7b,-516(%rdx){1to16}, %k2
 
 // CHECK: vfpclasspd $171, %zmm19, %k2
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd3,0xab]
           vfpclasspd $0xab, %zmm19, %k2
 
+// CHECK: vfpclasspd $171, %zmm19, %k2
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd3,0xab]
+          vfpclasspdz $0xab, %zmm19, %k2
+
 // CHECK: vfpclasspd $171, %zmm19, %k2 {%k6}
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x4e,0x66,0xd3,0xab]
           vfpclasspd $0xab, %zmm19, %k2 {%k6}
 
+// CHECK: vfpclasspd $171, %zmm19, %k2 {%k6}
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x4e,0x66,0xd3,0xab]
+          vfpclasspdz $0xab, %zmm19, %k2 {%k6}
+
 // CHECK: vfpclasspd $123,  %zmm19, %k2
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd3,0x7b]
           vfpclasspd $0x7b, %zmm19, %k2
 
+// CHECK: vfpclasspd $123,  %zmm19, %k2
+// CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0xd3,0x7b]
+          vfpclasspdz $0x7b, %zmm19, %k2
+
 // CHECK: vfpclasspdz $123, (%rcx), %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x11,0x7b]
           vfpclasspdz $0x7b,(%rcx), %k2
@@ -3623,9 +3695,13 @@
 // CHECK:  encoding: [0x62,0xb3,0xfd,0x48,0x66,0x94,0xf0,0x34,0x12,0x00,0x00,0x7b]
           vfpclasspdz $0x7b,4660(%rax,%r14,8), %k2
 
-// CHECK: vfpclasspdq $123, (%rcx){1to8}, %k2
+// CHECK: vfpclasspd $123, (%rcx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x11,0x7b]
+          vfpclasspd $0x7b,(%rcx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, (%rcx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x11,0x7b]
-          vfpclasspdq $0x7b,(%rcx){1to8}, %k2
+          vfpclasspdz $0x7b,(%rcx){1to8}, %k2
 
 // CHECK: vfpclasspdz $123, 8128(%rdx), %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x52,0x7f,0x7b]
@@ -3643,34 +3719,62 @@
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x48,0x66,0x92,0xc0,0xdf,0xff,0xff,0x7b]
           vfpclasspdz $0x7b,-8256(%rdx), %k2
 
-// CHECK: vfpclasspdq $123, 1016(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, 1016(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x7f,0x7b]
+          vfpclasspd $0x7b,1016(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, 1016(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x7f,0x7b]
-          vfpclasspdq $0x7b,1016(%rdx){1to8}, %k2
+          vfpclasspdz $0x7b,1016(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, 1024(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0x00,0x04,0x00,0x00,0x7b]
+          vfpclasspd $0x7b,1024(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, 1024(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, 1024(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0x00,0x04,0x00,0x00,0x7b]
-          vfpclasspdq $0x7b,1024(%rdx){1to8}, %k2
+          vfpclasspdz $0x7b,1024(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, -1024(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, -1024(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x80,0x7b]
-          vfpclasspdq $0x7b,-1024(%rdx){1to8}, %k2
+          vfpclasspd $0x7b,-1024(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, -1024(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x52,0x80,0x7b]
+          vfpclasspdz $0x7b,-1024(%rdx){1to8}, %k2
+
+// CHECK: vfpclasspd $123, -1032(%rdx){1to8}, %k2
+// CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0xf8,0xfb,0xff,0xff,0x7b]
+          vfpclasspd $0x7b,-1032(%rdx){1to8}, %k2
 
-// CHECK: vfpclasspdq $123, -1032(%rdx){1to8}, %k2
+// CHECK: vfpclasspd $123, -1032(%rdx){1to8}, %k2
 // CHECK:  encoding: [0x62,0xf3,0xfd,0x58,0x66,0x92,0xf8,0xfb,0xff,0xff,0x7b]
-          vfpclasspdq $0x7b,-1032(%rdx){1to8}, %k2
+          vfpclasspdz $0x7b,-1032(%rdx){1to8}, %k2
 
 // CHECK: vfpclassps $171, %zmm17, %k4
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xe1,0xab]
           vfpclassps $0xab, %zmm17, %k4
 
+// CHECK: vfpclassps $171, %zmm17, %k4
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xe1,0xab]
+          vfpclasspsz $0xab, %zmm17, %k4
+
 // CHECK: vfpclassps $171, %zmm17, %k4 {%k2}
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x4a,0x66,0xe1,0xab]
           vfpclassps $0xab, %zmm17, %k4 {%k2}
 
+// CHECK: vfpclassps $171, %zmm17, %k4 {%k2}
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x4a,0x66,0xe1,0xab]
+          vfpclasspsz $0xab, %zmm17, %k4 {%k2}
+
 // CHECK: vfpclassps $123,  %zmm17, %k4
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xe1,0x7b]
           vfpclassps $0x7b, %zmm17, %k4
 
+// CHECK: vfpclassps $123,  %zmm17, %k4
+// CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xe1,0x7b]
+          vfpclasspsz $0x7b, %zmm17, %k4
+
 // CHECK: vfpclasspsz $123, (%rcx), %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0x21,0x7b]
           vfpclasspsz $0x7b,(%rcx), %k4
@@ -3679,9 +3783,13 @@
 // CHECK:  encoding: [0x62,0xb3,0x7d,0x48,0x66,0xa4,0xf0,0x34,0x12,0x00,0x00,0x7b]
           vfpclasspsz $0x7b,4660(%rax,%r14,8), %k4
 
-// CHECK: vfpclasspsl $123, (%rcx){1to16}, %k4
+// CHECK: vfpclassps $123, (%rcx){1to16}, %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x21,0x7b]
-          vfpclasspsl $0x7b,(%rcx){1to16}, %k4
+          vfpclassps $0x7b,(%rcx){1to16}, %k4
+
+// CHECK: vfpclassps $123, (%rcx){1to16}, %k4
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x21,0x7b]
+          vfpclasspsz $0x7b,(%rcx){1to16}, %k4
 
 // CHECK: vfpclasspsz $123, 8128(%rdx), %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0x62,0x7f,0x7b]
@@ -3699,22 +3807,37 @@
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x48,0x66,0xa2,0xc0,0xdf,0xff,0xff,0x7b]
           vfpclasspsz $0x7b,-8256(%rdx), %k4
 
-// CHECK: vfpclasspsl $123, 508(%rdx){1to16}, %k4
+// CHECK: vfpclassps $123, 508(%rdx){1to16}, %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x62,0x7f,0x7b]
-          vfpclasspsl $0x7b,508(%rdx){1to16}, %k4
+          vfpclassps $0x7b,508(%rdx){1to16}, %k4
 
-// CHECK: vfpclasspsl $123, 512(%rdx){1to16}, %k4
+// CHECK: vfpclassps $123, 508(%rdx){1to16}, %k4
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x62,0x7f,0x7b]
+          vfpclasspsz $0x7b,508(%rdx){1to16}, %k4
+
+// CHECK: vfpclassps $123, 512(%rdx){1to16}, %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0xa2,0x00,0x02,0x00,0x00,0x7b]
-          vfpclasspsl $0x7b,512(%rdx){1to16}, %k4
+          vfpclassps $0x7b,512(%rdx){1to16}, %k4
 
-// CHECK: vfpclasspsl $123, -512(%rdx){1to16}, %k4
+// CHECK: vfpclassps $123, 512(%rdx){1to16}, %k4
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0xa2,0x00,0x02,0x00,0x00,0x7b]
+          vfpclasspsz $0x7b,512(%rdx){1to16}, %k4
+
+// CHECK: vfpclassps $123, -512(%rdx){1to16}, %k4
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x62,0x80,0x7b]
+          vfpclassps $0x7b,-512(%rdx){1to16}, %k4
+
+// CHECK: vfpclassps $123, -512(%rdx){1to16}, %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0x62,0x80,0x7b]
-          vfpclasspsl $0x7b,-512(%rdx){1to16}, %k4
+          vfpclasspsz $0x7b,-512(%rdx){1to16}, %k4
 
-// CHECK: vfpclasspsl $123, -516(%rdx){1to16}, %k4
+// CHECK: vfpclassps $123, -516(%rdx){1to16}, %k4
 // CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0xa2,0xfc,0xfd,0xff,0xff,0x7b]
-          vfpclasspsl $0x7b,-516(%rdx){1to16}, %k4
+          vfpclassps $0x7b,-516(%rdx){1to16}, %k4
 
+// CHECK: vfpclassps $123, -516(%rdx){1to16}, %k4
+// CHECK:  encoding: [0x62,0xf3,0x7d,0x58,0x66,0xa2,0xfc,0xfd,0xff,0xff,0x7b]
+          vfpclasspsz $0x7b,-516(%rdx){1to16}, %k4
 
 // CHECK: vcvtuqq2ps {rn-sae}, %zmm21, %ymm18
 // CHECK:  encoding: [0x62,0xa1,0xff,0x18,0x7a,0xd5]
